import { PublicKey } from '@solana/web3.js';
import nacl from 'tweetnacl';
import { Driver } from '../Driver';
export class IdentityDriver extends Driver {
    async verifyMessage(message, signature) {
        return nacl.sign.detached.verify(message, signature, this.publicKey.toBytes());
    }
    is(that) {
        if (!(that instanceof PublicKey)) {
            that = that.publicKey;
        }
        return this.publicKey.equals(that);
    }
}
//# sourceMappingURL=IdentityDriver.js.map